/**
 * Copyright (C) 2013 Kosmos <contact@kosmos.fr>
 *
 * Projet: blog
 * Version: 1.1-RC-7
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.kosmos.blog.sgbd;

import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;

import com.jsbsoft.jtf.database.OMContext;

/**
 * Classe d'acces aux donnees pour blog.
 */
public class BlogDB {

	protected OMContext ctx = null;

	protected String qualifier = null;

	private ResultSet rs = null;

	private Long idBlog = null;

	private String titre = null;

	private String description = null;

	private String thematique = null;

	private String archivage = null;

	private String code = null;

	private String codeRubrique = null;

	private String codeRattachement = null;

	private String metaKeywords = null;

	private String metaDescription = null;

	private String titreEncadre = null;

	private String contenuEncadre = null;

	private String encadreRecherche = null;

	private String encadreRechercheBis = null;

	private Date dateAlerte = null;

	private String messageAlerte = null;

	private Date dateCreation = null;

	private Date dateProposition = null;

	private Date dateValidation = null;

	private Date dateModification = null;

	private String codeRedacteur = null;

	private String codeValidation = null;

	private String langue = null;

	private String etatObjet = null;

	private Long nbHits = null;

	private String diffusionPublicVise = null;

	private String diffusionModeRestriction = null;

	private String diffusionPublicViseRestriction = null;

	public void setIdBlog(final Long idBlog) {
		this.idBlog = idBlog;
	}

	public void setTitre(final String titre) {
		this.titre = titre;
	}

	public void setDescription(final String description) {
		this.description = description;
	}

	public void setThematique(final String thematique) {
		this.thematique = thematique;
	}

	public void setArchivage(final String archivage) {
		this.archivage = archivage;
	}

	public void setCode(final String code) {
		this.code = code;
	}

	public void setCodeRubrique(final String codeRubrique) {
		this.codeRubrique = codeRubrique;
	}

	public void setCodeRattachement(final String codeRattachement) {
		this.codeRattachement = codeRattachement;
	}

	public void setMetaKeywords(final String metaKeywords) {
		this.metaKeywords = metaKeywords;
	}

	public void setMetaDescription(final String metaDescription) {
		this.metaDescription = metaDescription;
	}

	public void setTitreEncadre(final String titreEncadre) {
		this.titreEncadre = titreEncadre;
	}

	public void setContenuEncadre(final String contenuEncadre) {
		this.contenuEncadre = contenuEncadre;
	}

	public void setEncadreRecherche(final String encadreRecherche) {
		this.encadreRecherche = encadreRecherche;
	}

	public void setEncadreRechercheBis(final String encadreRechercheBis) {
		this.encadreRechercheBis = encadreRechercheBis;
	}

	public void setDateAlerte(final Date dateAlerte) {
		this.dateAlerte = dateAlerte;
	}

	public void setMessageAlerte(final String messageAlerte) {
		this.messageAlerte = messageAlerte;
	}

	public void setDateCreation(final Date dateCreation) {
		this.dateCreation = dateCreation;
	}

	public void setDateProposition(final Date dateProposition) {
		this.dateProposition = dateProposition;
	}

	public void setDateValidation(final Date dateValidation) {
		this.dateValidation = dateValidation;
	}

	public void setDateModification(final Date dateModification) {
		this.dateModification = dateModification;
	}

	public void setCodeRedacteur(final String codeRedacteur) {
		this.codeRedacteur = codeRedacteur;
	}

	public void setCodeValidation(final String codeValidation) {
		this.codeValidation = codeValidation;
	}

	public void setLangue(final String langue) {
		this.langue = langue;
	}

	public void setEtatObjet(final String etatObjet) {
		this.etatObjet = etatObjet;
	}

	public void setNbHits(final Long nbHits) {
		this.nbHits = nbHits;
	}

	public void setDiffusionPublicVise(final String diffusionPublicVise) {
		this.diffusionPublicVise = diffusionPublicVise;
	}

	public void setDiffusionModeRestriction(final String diffusionModeRestriction) {
		this.diffusionModeRestriction = diffusionModeRestriction;
	}

	public void setDiffusionPublicViseRestriction(final String diffusionPublicViseRestriction) {
		this.diffusionPublicViseRestriction = diffusionPublicViseRestriction;
	}

	public Long getIdBlog() {
		return idBlog;
	}

	public String getTitre() {
		return titre;
	}

	public String getDescription() {
		return description;
	}

	public String getThematique() {
		return thematique;
	}

	public String getArchivage() {
		return archivage;
	}

	public String getCode() {
		return code;
	}

	public String getCodeRubrique() {
		return codeRubrique;
	}

	public String getCodeRattachement() {
		return codeRattachement;
	}

	public String getMetaKeywords() {
		return metaKeywords;
	}

	public String getMetaDescription() {
		return metaDescription;
	}

	public String getTitreEncadre() {
		return titreEncadre;
	}

	public String getContenuEncadre() {
		return contenuEncadre;
	}

	public String getEncadreRecherche() {
		return encadreRecherche;
	}

	public String getEncadreRechercheBis() {
		return encadreRechercheBis;
	}

	public Date getDateAlerte() {
		return dateAlerte;
	}

	public String getMessageAlerte() {
		return messageAlerte;
	}

	public Date getDateCreation() {
		return dateCreation;
	}

	public Date getDateProposition() {
		return dateProposition;
	}

	public Date getDateValidation() {
		return dateValidation;
	}

	public Date getDateModification() {
		return dateModification;
	}

	public String getCodeRedacteur() {
		return codeRedacteur;
	}

	public String getCodeValidation() {
		return codeValidation;
	}

	public String getLangue() {
		return langue;
	}

	public String getEtatObjet() {
		return etatObjet;
	}

	public Long getNbHits() {
		return nbHits;
	}

	public String getDiffusionPublicVise() {
		return diffusionPublicVise;
	}

	public String getDiffusionModeRestriction() {
		return diffusionModeRestriction;
	}

	public String getDiffusionPublicViseRestriction() {
		return diffusionPublicViseRestriction;
	}

	@Override
	public String toString() {
		return toString(".");
	}

	public String toString(final String aSeparator) {
		final String s = "" + getIdBlog() + aSeparator + getTitre() + aSeparator + getDescription() + aSeparator + getThematique() + aSeparator + getArchivage() + aSeparator + getCode() + aSeparator + getCodeRubrique() + aSeparator + getCodeRattachement() + aSeparator + getMetaKeywords() + aSeparator + getMetaDescription() + aSeparator + getTitreEncadre() + aSeparator + getContenuEncadre() + aSeparator + getEncadreRecherche() + aSeparator + getEncadreRechercheBis() + aSeparator + getDateAlerte() + aSeparator + getMessageAlerte() + aSeparator + getDateCreation() + aSeparator + getDateProposition() + aSeparator + getDateValidation() + aSeparator + getDateModification() + aSeparator + getCodeRedacteur() + aSeparator + getCodeValidation() + aSeparator + getLangue() + aSeparator + getEtatObjet() + aSeparator + getNbHits() + aSeparator + getDiffusionPublicVise() + aSeparator + getDiffusionModeRestriction() + aSeparator + getDiffusionPublicViseRestriction();
		return s;
	}

	public void setCtx(final OMContext _ctx) {
		ctx = _ctx;
	}

	public void setQualifier(final String qualifier) {
		this.qualifier = qualifier;
	}

	private Connection getConnection() {
		return ctx.getConnection();
	}

	public void add() throws Exception {
		PreparedStatement stmt = null;
		ResultSet rs = null;
		try {
			stmt = getConnection().prepareStatement(
				"insert into BLOG (" + "ID_BLOG , " + "TITRE , " + "DESCRIPTION , " + "THEMATIQUE , " + "ARCHIVAGE , " + "CODE , " + "CODE_RUBRIQUE , " + "CODE_RATTACHEMENT , " + "META_KEYWORDS , " + "META_DESCRIPTION , " + "TITRE_ENCADRE , " + "CONTENU_ENCADRE , " + "ENCADRE_RECHERCHE , " + "ENCADRE_RECHERCHE_BIS , " + "DATE_ALERTE , " + "MESSAGE_ALERTE , " + "DATE_CREATION , " + "DATE_PROPOSITION , " + "DATE_VALIDATION , " + "DATE_MODIFICATION , " + "CODE_REDACTEUR , " + "CODE_VALIDATION , " + "LANGUE , " + "ETAT_OBJET , " + "NB_HITS , " + "DIFFUSION_PUBLIC_VISE , " + "DIFFUSION_MODE_RESTRICTION , " + "DIFFUSION_PUBLIC_VISE_RESTRICTION" + ") values (" + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?, " + "?)");
			stmt.setObject(1, getIdBlog(), Types.BIGINT);
			stmt.setObject(2, getTitre(), Types.VARCHAR);
			stmt.setObject(3, getDescription(), Types.LONGVARCHAR);
			stmt.setObject(4, getThematique(), Types.LONGVARCHAR);
			stmt.setObject(5, getArchivage(), Types.VARCHAR);
			stmt.setObject(6, getCode(), Types.VARCHAR);
			stmt.setObject(7, getCodeRubrique(), Types.VARCHAR);
			stmt.setObject(8, getCodeRattachement(), Types.VARCHAR);
			stmt.setObject(9, getMetaKeywords(), Types.LONGVARCHAR);
			stmt.setObject(10, getMetaDescription(), Types.LONGVARCHAR);
			stmt.setObject(11, getTitreEncadre(), Types.VARCHAR);
			stmt.setObject(12, getContenuEncadre(), Types.LONGVARCHAR);
			stmt.setObject(13, getEncadreRecherche(), Types.VARCHAR);
			stmt.setObject(14, getEncadreRechercheBis(), Types.VARCHAR);
			stmt.setObject(15, getDateAlerte(), Types.DATE);
			stmt.setObject(16, getMessageAlerte(), Types.LONGVARCHAR);
			stmt.setObject(17, getDateCreation(), Types.TIMESTAMP);
			stmt.setObject(18, getDateProposition(), Types.TIMESTAMP);
			stmt.setObject(19, getDateValidation(), Types.TIMESTAMP);
			stmt.setObject(20, getDateModification(), Types.TIMESTAMP);
			stmt.setObject(21, getCodeRedacteur(), Types.VARCHAR);
			stmt.setObject(22, getCodeValidation(), Types.VARCHAR);
			stmt.setObject(23, getLangue(), Types.VARCHAR);
			stmt.setObject(24, getEtatObjet(), Types.VARCHAR);
			stmt.setObject(25, getNbHits(), Types.BIGINT);
			stmt.setObject(26, getDiffusionPublicVise(), Types.LONGVARCHAR);
			stmt.setObject(27, getDiffusionModeRestriction(), Types.VARCHAR);
			stmt.setObject(28, getDiffusionPublicViseRestriction(), Types.LONGVARCHAR);
			final int rowsAffected = stmt.executeUpdate();
			if (rowsAffected == 0) {
				throw new Exception("METHOD_AFFCTD_NOROWS");
			} else if (rowsAffected > 1) {
				throw new Exception("METHOD_AFFCTD_MULTROWS");
			}
			rs = stmt.getGeneratedKeys();
			rs.next();
			setIdBlog(rs.getLong(1));
		} catch (final SQLException e) {
			throw new Exception("ERROR_IN_METHOD add()", e);
		} finally {
			if (rs != null) {
				rs.close();
			}
			if (stmt != null) {
				stmt.close();
			}
		}
	}

	public void delete() throws Exception {
		PreparedStatement stmt = null;
		try {
			stmt = getConnection().prepareStatement("delete from BLOG " + "where ID_BLOG = ?");
			stmt.setObject(1, getIdBlog(), Types.BIGINT);
			final int rowsAffected = stmt.executeUpdate();
			if (rowsAffected == 0) {
				throw new Exception("METHOD_AFFCTD_NOROWS");
			} else if (rowsAffected > 1) {
				throw new Exception("METHOD_AFFCTD_MULTROWS");
			}
		} catch (final SQLException e) {
			throw new Exception("ERROR_IN_METHOD delete()", e);
		} finally {
			if (stmt != null) {
				stmt.close();
			}
		}
	}

	public String getSQLBaseQuery() {
		final String query = "select distinct " + "T1.ID_BLOG, " + "T1.TITRE, " + "T1.DESCRIPTION, " + "T1.THEMATIQUE, " + "T1.ARCHIVAGE, " + "T1.CODE, " + "T1.CODE_RUBRIQUE, " + "T1.CODE_RATTACHEMENT, " + "T1.META_KEYWORDS, " + "T1.META_DESCRIPTION, " + "T1.TITRE_ENCADRE, " + "T1.CONTENU_ENCADRE, " + "T1.ENCADRE_RECHERCHE, " + "T1.ENCADRE_RECHERCHE_BIS, " + "T1.DATE_ALERTE, " + "T1.MESSAGE_ALERTE, " + "T1.DATE_CREATION, " + "T1.DATE_PROPOSITION, " + "T1.DATE_VALIDATION, " + "T1.DATE_MODIFICATION, " + "T1.CODE_REDACTEUR, " + "T1.CODE_VALIDATION, " + "T1.LANGUE, " + "T1.ETAT_OBJET, " + "T1.NB_HITS, " + "T1.DIFFUSION_PUBLIC_VISE, " + "T1.DIFFUSION_MODE_RESTRICTION, " + "T1.DIFFUSION_PUBLIC_VISE_RESTRICTION " + "from " + (qualifier == null ? "" : qualifier) + "BLOG T1 ";
		return query;
	}

	public String getSQLBaseOptimizedQuery() {
		final String query = "select " + "T1.ID_BLOG, " + "T1.CODE, " + "T1.LANGUE " + "from " + (qualifier == null ? "" : qualifier) + "BLOG T1 ";
		return query;
	}

	/**
	 * Renvoie l'element suivant du ResultSet.
	 */
	public boolean nextItem() throws Exception {
		boolean res = false;
		try {
			if (rs.next()) {
				if (ctx.getDatas().get("optimizedSelect") != null) {
					retrieveFromOptimizedRS();
				} else {
					retrieveFromRS();
				}
				res = true;
			} else {
				try {
					rs.close();
				} finally {
					rs = null;
				}
			}
		} catch (final Exception e) {
			throw new Exception("ERROR_IN_METHOD nextItem()", e);
		}
		return res;
	}

	/**
	 * Recuperation d'une ligne de la base de donnees.
	 */
	public void retrieve() throws Exception {
		PreparedStatement stmt = null;
		try {
			stmt = getConnection().prepareStatement(
				"select " + "T1.ID_BLOG, " + "T1.TITRE, " + "T1.DESCRIPTION, " + "T1.THEMATIQUE, " + "T1.ARCHIVAGE, " + "T1.CODE, " + "T1.CODE_RUBRIQUE, " + "T1.CODE_RATTACHEMENT, " + "T1.META_KEYWORDS, " + "T1.META_DESCRIPTION, " + "T1.TITRE_ENCADRE, " + "T1.CONTENU_ENCADRE, " + "T1.ENCADRE_RECHERCHE, " + "T1.ENCADRE_RECHERCHE_BIS, " + "T1.DATE_ALERTE, " + "T1.MESSAGE_ALERTE, " + "T1.DATE_CREATION, " + "T1.DATE_PROPOSITION, " + "T1.DATE_VALIDATION, " + "T1.DATE_MODIFICATION, " + "T1.CODE_REDACTEUR, " + "T1.CODE_VALIDATION, " + "T1.LANGUE, " + "T1.ETAT_OBJET, " + "T1.NB_HITS, " + "T1.DIFFUSION_PUBLIC_VISE, " + "T1.DIFFUSION_MODE_RESTRICTION, " + "T1.DIFFUSION_PUBLIC_VISE_RESTRICTION " + "from BLOG T1 " + "where T1.ID_BLOG = ?");
			stmt.setObject(1, getIdBlog(), Types.BIGINT);
			rs = stmt.executeQuery();
			if (!rs.next()) {
				throw new Exception("retrieve : METHOD_NO_RESULTS");
			}
			retrieveFromRS();
		} catch (final SQLException e) {
			throw new Exception("ERROR_IN_METHOD retrieve()", e);
		} finally {
			if (rs != null) {
				rs.close();
			}
			if (stmt != null) {
				stmt.close();
			}
		}
	}

	private void retrieveFromRS() throws Exception {
		try {
			setIdBlog(new Long(rs.getLong(1)));
			setTitre(rs.getString(2));
			setDescription(rs.getString(3));
			setThematique(rs.getString(4));
			setArchivage(rs.getString(5));
			setCode(rs.getString(6));
			setCodeRubrique(rs.getString(7));
			setCodeRattachement(rs.getString(8));
			setMetaKeywords(rs.getString(9));
			setMetaDescription(rs.getString(10));
			setTitreEncadre(rs.getString(11));
			setContenuEncadre(rs.getString(12));
			setEncadreRecherche(rs.getString(13));
			setEncadreRechercheBis(rs.getString(14));
			setDateAlerte(rs.getDate(15));
			setMessageAlerte(rs.getString(16));
			setDateCreation(new Date(rs.getTimestamp(17).getTime()));
			setDateProposition(new Date(rs.getTimestamp(18).getTime()));
			setDateValidation(new Date(rs.getTimestamp(19).getTime()));
			setDateModification(new Date(rs.getTimestamp(20).getTime()));
			setCodeRedacteur(rs.getString(21));
			setCodeValidation(rs.getString(22));
			setLangue(rs.getString(23));
			setEtatObjet(rs.getString(24));
			setNbHits(new Long(rs.getLong(25)));
			setDiffusionPublicVise(rs.getString(26));
			setDiffusionModeRestriction(rs.getString(27));
			setDiffusionPublicViseRestriction(rs.getString(28));
		} catch (final SQLException e) {
			throw new Exception("ERROR_IN_METHOD retrieveFromRS()", e);
		}
	}

	private void retrieveFromOptimizedRS() throws Exception {
		try {
			// get output from result set
			setIdBlog(new Long(rs.getLong(1)));
			setCode(rs.getString(2));
			setLangue(rs.getString(3));
		} catch (final SQLException e) {
			throw new Exception("ERROR_IN_METHOD retrieveFromOptimizedRS()", e);
		}
	}

	/**
	 * Cette methode optimise l'execution de la requete (pas de count)
	 * 
	 * @param sqlSuffix
	 * @throws Exception
	 */
	public void selectNoCount(final String sqlSuffix) throws Exception {
		PreparedStatement stmt = null;
		try {
			String query = getSQLBaseQuery();
			if (sqlSuffix != null) {
				query += sqlSuffix;
			}
			stmt = getConnection().prepareStatement(query);
			rs = stmt.executeQuery();
		} catch (final SQLException e) {
			throw new Exception("SELECT_FAILED", e);
		}
	}

	public int select(final String sqlSuffix) throws Exception {
		int count = 0;
		if (ctx.getDatas().get("optimizedObject") != null && ctx.getDatas().get("optimizedSelect") != null) {
			count = selectNoCountOptimized(sqlSuffix);
		} else {
			PreparedStatement stmt = null;
			try {
				// recuperation nombre de lignes
				String query = "select count(distinct T1.ID_BLOG) from " + (qualifier == null ? "" : qualifier) + "BLOG T1 ";
				if (sqlSuffix != null) {
					query += sqlSuffix;
				}
				stmt = getConnection().prepareStatement(query);
				rs = stmt.executeQuery();
				rs.next();
				count = rs.getInt(1);
				query = getSQLBaseQuery();
				if (sqlSuffix != null) {
					query += sqlSuffix;
				}
				stmt = getConnection().prepareStatement(query);
				rs = stmt.executeQuery();
			} catch (final SQLException e) {
				throw new Exception("SELECT_FAILED", e);
			}
		}
		return count;
	}

	private int selectNoCountOptimized(final String sqlSuffix) throws Exception {
		PreparedStatement stmt = null;
		final int count = -1;
		try {
			String query = getSQLBaseOptimizedQuery();
			if (sqlSuffix != null) {
				query += sqlSuffix;
			}
			if (ctx.getDatas().get("optimizedLimit") != null) {
				query += " limit 0," + (String) ctx.getDatas().get("optimizedLimit") + "0";
			}
			stmt = getConnection().prepareStatement(query);
			rs = stmt.executeQuery();
		} catch (final SQLException e) {
			throw new Exception("SELECT_FAILED", e);
		}
		return count;
	}

	/**
	 * Mise a jour d'une ligne de la base de donnees.
	 */
	public void update() throws Exception {
		PreparedStatement stmt = null;
		try {
			stmt = getConnection().prepareStatement(
				"update BLOG set " + "ID_BLOG = ?, " + "TITRE = ?, " + "DESCRIPTION = ?, " + "THEMATIQUE = ?, " + "ARCHIVAGE = ?, " + "CODE = ?, " + "CODE_RUBRIQUE = ?, " + "CODE_RATTACHEMENT = ?, " + "META_KEYWORDS = ?, " + "META_DESCRIPTION = ?, " + "TITRE_ENCADRE = ?, " + "CONTENU_ENCADRE = ?, " + "ENCADRE_RECHERCHE = ?, " + "ENCADRE_RECHERCHE_BIS = ?, " + "DATE_ALERTE = ?, " + "MESSAGE_ALERTE = ?, " + "DATE_CREATION = ?, " + "DATE_PROPOSITION = ?, " + "DATE_VALIDATION = ?, " + "DATE_MODIFICATION = ?, " + "CODE_REDACTEUR = ?, " + "CODE_VALIDATION = ?, " + "LANGUE = ?, " + "ETAT_OBJET = ?, " + "NB_HITS = ?, " + "DIFFUSION_PUBLIC_VISE = ?, " + "DIFFUSION_MODE_RESTRICTION = ?, " + "DIFFUSION_PUBLIC_VISE_RESTRICTION = ? " + "where ID_BLOG = ?");
			stmt.setObject(1, getIdBlog(), Types.BIGINT);
			stmt.setObject(2, getTitre(), Types.VARCHAR);
			stmt.setObject(3, getDescription(), Types.LONGVARCHAR);
			stmt.setObject(4, getThematique(), Types.LONGVARCHAR);
			stmt.setObject(5, getArchivage(), Types.VARCHAR);
			stmt.setObject(6, getCode(), Types.VARCHAR);
			stmt.setObject(7, getCodeRubrique(), Types.VARCHAR);
			stmt.setObject(8, getCodeRattachement(), Types.VARCHAR);
			stmt.setObject(9, getMetaKeywords(), Types.LONGVARCHAR);
			stmt.setObject(10, getMetaDescription(), Types.LONGVARCHAR);
			stmt.setObject(11, getTitreEncadre(), Types.VARCHAR);
			stmt.setObject(12, getContenuEncadre(), Types.LONGVARCHAR);
			stmt.setObject(13, getEncadreRecherche(), Types.VARCHAR);
			stmt.setObject(14, getEncadreRechercheBis(), Types.VARCHAR);
			stmt.setObject(15, getDateAlerte(), Types.DATE);
			stmt.setObject(16, getMessageAlerte(), Types.LONGVARCHAR);
			stmt.setObject(17, getDateCreation(), Types.TIMESTAMP);
			stmt.setObject(18, getDateProposition(), Types.TIMESTAMP);
			stmt.setObject(19, getDateValidation(), Types.TIMESTAMP);
			stmt.setObject(20, getDateModification(), Types.TIMESTAMP);
			stmt.setObject(21, getCodeRedacteur(), Types.VARCHAR);
			stmt.setObject(22, getCodeValidation(), Types.VARCHAR);
			stmt.setObject(23, getLangue(), Types.VARCHAR);
			stmt.setObject(24, getEtatObjet(), Types.VARCHAR);
			stmt.setObject(25, getNbHits(), Types.BIGINT);
			stmt.setObject(26, getDiffusionPublicVise(), Types.LONGVARCHAR);
			stmt.setObject(27, getDiffusionModeRestriction(), Types.VARCHAR);
			stmt.setObject(28, getDiffusionPublicViseRestriction(), Types.LONGVARCHAR);
			stmt.setObject(29, getIdBlog(), Types.BIGINT);
			stmt.executeUpdate();
		} catch (final SQLException e) {
			throw new Exception("ERROR_IN_METHOD update()", e);
		} finally {
			if (stmt != null) {
				stmt.close();
			}
		}
	}
}
